/* vim:fdm=marker ts=4 et ai
 * {{{
 *
 * (c) by Alexander Neumann <alexander@bumpern.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * For more information on the GPL, please go to:
 * http://www.gnu.org/copyleft/gpl.html
 }}} */

#ifndef _7SEG_H
#define _7SEG_H

#include <stdint.h>
#include <util/delay.h>
#include "clock.h"

/* constants and global variables */
/* {{{ */
#define L7SEG_DDR DDRC
#define L7SEG_PORT PORTC

#define L7SEG_H_10 0
#define L7SEG_H_01 1
#define L7SEG_M_10 2
#define L7SEG_M_01 3
#define L7SEG_S_10 4
#define L7SEG_S_01 5

#define L7SEG_SEG_A 0
#define L7SEG_SEG_B 1
#define L7SEG_SEG_C 2
#define L7SEG_SEG_D 3
#define L7SEG_SEG_E 4
#define L7SEG_SEG_F 5
#define L7SEG_SEG_G 6
#define L7SEG_SEG_H 7

#define L7SEG_PORT_IDX_CLEAR 0
#define L7SEG_PORT_IDX_CLOCK 1
#define L7SEG_PORT_IDX_ENABLE 2
#define L7SEG_PORT_SEG_CLEAR 5
#define L7SEG_PORT_SEG_CLOCK 6
#define L7SEG_PORT_SEG_DATA 7

extern char *l7seg_buffer; //this will be displayed instead of time
extern uint32_t l7dontdisplaytime; //until this timestamp the 7segment clock will show the buffer contents instead of time

//about 5 /us delay for length of trigger pulses
#define L7SEG_DELAY() _delay_loop_1(33)
/* }}} */

void l7seg_init(void);

void l7seg_periodic(void);

uint8_t l7seg_segvalue(uint8_t decval);

#endif
